
ChiliProject - Bug # 209: Don't hardcode user viewable labels (like "Path to .git repository")

Status: Closed Priority: Normal
Author: Holger Just Category: SCM
Created: 2011-02-19 Assignee: Felix Schäfer
Updated: 2011-03-19 Due date:
Remote issue URL:
Affected version:
Description: The repository helper has hardcoded English labels which are shown in the repository creation view in the 

project's settings. These should be replaced by i18n strings.

These strings are used in almost all @*:_field_tags methods@ in the @repository_helper@: 
source:app/helpers/repository_helper.rb#L174

Associated revisions
2011-03-18 09:08 am - Ivan Evtuhovich 
Move repositories_helper labels to translation, refs #209

2011-03-19 10:57 am - Felix SchÃ¤fer 
Add new translation strings to all locales. #209

History
2011-03-18 08:11 am - Ivan Evtuhovich
https://github.com/chiliproject/chiliproject/pull/28

Please review my request, i've fixed this problem

2011-03-18 08:42 am - Felix Schäfer
- Status changed from Open to Ready for review

First quick look: looks good, the strings are missing in all but  the english and russian locale files though. There's a rake task to go through all locale 
files and copy the missing ones from the en locale file, remember to use it next time :-)

2011-03-18 11:57 pm - Eric Davis
- Target version set to 1.2.0

- Assignee set to Eric Davis

Looks good to me too. I'll merge it this weekend unless someone else does it first.

2011-03-19 10:00 am - Felix Schäfer
- Assignee changed from Eric Davis to Felix Schäfer

- Status changed from Ready for review to Closed

Merged in commit:a80515fb20f98d545a9bd81939cea132ffe8da3e.

2011-03-19 10:02 am - Felix Schäfer
And now I've forgotten the most important part: thanks Ivan :-)
2011-03-19 11:21 am - Toshi MARUYAMA
- File redmine.png added

- Status changed from Closed to Open

- File chili.png added

Not fixed.

If repository path is empty, "URL can't be blank" shows.

h2. chili
!chili.png!

h2. redmine
!redmine.png!

2011-03-19 12:23 pm - Ivan Evtuhovich
I think I18n brokes standard rails behavior. 

I've tried to translate repository/git url attribute in a standard rails way, adding:
<pre><code lang="yaml">
  activerecord:
    models:
      repository/git:
        attributes:
          url: Path to git repository
</code></pre>
But there an error occur, when i try to save git repo with empty url:

<pre>

ActionView::TemplateError (translation data {:attributes=>{:url=>"Path to git repository"}} can not be used with :count => 1) on line #6 of 
app/views/projects/settings/_repository.rhtml:
3:                    :builder => TabularFormBuilder,
4:                    :lang => current_language do |f| %>
5: 
6: <%= error_messages_for 'repository' %>
7: 
8: <div class="box tabular">
9: <p><%= label_tag('repository_scm', l(:label_scm)) %><%= scm_select_tag(@repository) %></p>

    /home/brun/.rvm/gems/ruby-1.8.7-p334/gems/i18n-0.4.2/lib/i18n/backend/base.rb:138:in `pluralize'
    /home/brun/.rvm/gems/ruby-1.8.7-p334/gems/i18n-0.4.2/lib/i18n/backend/base.rb:45:in `translate'
    /home/brun/.rvm/gems/ruby-1.8.7-p334/gems/i18n-0.4.2/lib/i18n/backend/fallbacks.rb:47:in `translate'
    /home/brun/.rvm/gems/ruby-1.8.7-p334/gems/i18n-0.4.2/lib/i18n/backend/fallbacks.rb:45:in `each'
    /home/brun/.rvm/gems/ruby-1.8.7-p334/gems/i18n-0.4.2/lib/i18n/backend/fallbacks.rb:45:in `translate'
    /home/brun/.rvm/gems/ruby-1.8.7-p334/gems/i18n-0.4.2/lib/i18n.rb:160:in `translate'
    config/initializers/10-patches.rb:36:in `full_messages'
    config/initializers/10-patches.rb:21:in `each'
    config/initializers/10-patches.rb:21:in `full_messages'
    config/initializers/10-patches.rb:20:in `full_messages'
</pre>

And the other problem with TabularFormBuilder#label_for_field - it isn't render translated name for AR attributes.

I want some comments from you, to continue work on problem

2011-03-19 01:06 pm - Ivan Evtuhovich
source:config/initializers/10-patches.rb#L10

<pre><code class="ruby">
    def self.human_attribute_name(attr)
      l("field_#{attr.to_s.gsub(/_id$/, '')}")
    end
</code></pre>

Therefore it translates url field in all models as a 'URL'. I think this behavior is unclear for most rails developers

2011-03-19 01:34 pm - Felix Schäfer
- Status changed from Open to Closed

Toshi MARUYAMA wrote:
> Not fixed.
> 
> If repository path is empty, "URL can't be blank" shows.

Thanks for reporting, but this does not affect this issue directly, please open a new related issue for this.

Ivan Evtuhovich wrote:
> I think this behavior is unclear for most rails developers

It is. We should evaluate if we want to continue to support it or if we should try to phase it out. This should go to a new issue too, though probably not 
the same as the one Toshi reported.

2011-03-19 02:41 pm - Ivan Evtuhovich
#296, #297 - i create two separate tasks

Files
chili.png 20.6 kB 2011-03-19 Toshi MARUYAMA
redmine.png 25.4 kB 2011-03-19 Toshi MARUYAMA
